<template>
  <div>
    <b-container fluid>
      <b-row>
        <b-col>
          <b-breadcrumb :items="breadcrumb"></b-breadcrumb>
          <h2>{{ issue.title }}</h2>

          <div class="issue-description">
            {{ issue.description }}
          </div>

          <b-nav pills small class="activity-select-buttons">
            <b-nav-item active>Comments</b-nav-item>
            <b-nav-item>Activity</b-nav-item>
          </b-nav>
        </b-col>
        <b-col cols="20percent">
          <b-dropdown v-if="issue.state != undefined" :text="issue.state.name" class="issue-state-button" :class="'issue-state-button-' + issue.state.category">
            <b-dropdown-item 
              href="#" 
              class="link-state" 
              :class="'link-state-' + transition.to_state.category" 
              v-for="transition in issue.state.transitions" 
              :key="transition.id"
              v-on:click="transitionIssue(transition.to_state)"
            >
              {{ transition.name }}
            </b-dropdown-item>
            <b-dropdown-divider />
            <b-dropdown-item href="#">View Workflow</b-dropdown-item>
          </b-dropdown>
          
          <DetailSidebarItem title="Assignees">
            <span v-if="issue.assignees != undefined && issue.assignees.length==0">
              <i>Unassigned</i>
            </span>
            <span v-for="assignee in issue.assignees" :key="assignee.id">
              {{ assignee.display_name }}
            </span>
          </DetailSidebarItem>

          <DetailSidebarItem title="Reporter">
            <span v-if="issue.reporter != undefined">{{ issue.reporter.display_name }}</span>
          </DetailSidebarItem>

          <DetailSidebarItem title="Priority">
            <span v-if="issue.priority != undefined">{{ issue.priority }}</span>
          </DetailSidebarItem>

          <DetailSidebarItem title="Tags">
            <span v-if="issue.tags != undefined && issue.tags.length==0">
              <i>None</i>
            </span>
            <b-badge variant="success" v-for="tag in issue.tags" :key="tag">{{ tag }}</b-badge>
          </DetailSidebarItem>

          <DetailSidebarItem title="Parent">
            <i>Not Implemented</i>
          </DetailSidebarItem>

          <DetailSidebarItem title="Cycle">
            <i>Not Implemented</i>
          </DetailSidebarItem>

          <DetailSidebarItem title="Developer">
            <i>Not Implemented</i>
          </DetailSidebarItem>
        </b-col>
      </b-row>
    </b-container>
  </div>
</template>

<script>
import { mapState } from 'vuex'
import DetailSidebarItem from '@/components/Layout/DetailSidebarItem.vue'

export default {
  name: 'IssuesView',
  components: {
    DetailSidebarItem
  },
  props: ['sidebarActiveKey'],
  created() {
    this.$emit('setSidebarActive', this.sidebarActiveKey);
    this.$store.dispatch('issues/issues/getIssueByKey', this.$route.params.key);
  },
  computed: mapState({
    issue() {
      return this.$store.getters['issues/issues/getIssueByKey'](this.$route.params.key);
    },
    breadcrumb() {
      let currentProject = this.$store.getters['issues/projects/getProjectDetailsByParams'](this.$route.params);

      return [
        {
          text: 'Issues',
          href: this.$router.resolve({ name: 'IssuesHomeDashboard' }).href
        },
        {
          text: currentProject['name'],
          href: this.$router.resolve({ name: 'IssuesProjectIssuesList', params: { identifier: currentProject['identifier'] } }).href
        },
        {
          text: this.$route.params.key,
          active: true
        }
      ]
    }
  }),
  data() {
    return {
      
    }
  },
  methods: {
    transitionIssue(to_state) {
      let key = this.$route.params.key;
      let issue_data = {
        issue: {
          state_id: to_state.id
        }
      }

      this.$store.dispatch('issues/issues/updateIssueByKey', { key, issue_data })
        .then(() => {
          console.log('transitioned');
        })
        .catch(error => {
          this.$bvToast.toast(error, {
            title: 'Transition Error',
            toaster: 'b-toaster-top-center',
            solid: true,
            appendToast: false
          });
        })
    }
  }
}
</script>

<style lang="scss">
$state-todo-color: gray;
$state-inprogress-color: #007bff;
$state-closed-color: #28a745;

.card-body .container-fluid {
  padding: 0;
}
.breadcrumb {
  background: none;
  padding: 0;
  margin: 0 0 6px 0;
}
.badge {
  margin: 0 2px;
}

.issue-state-button {
  margin-bottom: 5px;

  &.issue-state-button-todo button {
    border: 0;
    background-color: $state-todo-color !important;
  }
  &.issue-state-button-in_progress button {
    border: 0;
    background-color: $state-inprogress-color !important;
  }
  &.issue-state-button-closed button {
    border: 0;
    background-color: $state-closed-color !important;
  }
}

.issue-description {
  margin: 5px 0 25px 0;
}

.activity-select-buttons {
  a {
    padding: 0.25rem 0.5rem;
  }
}

.link-state {
  margin: 2px 0;
  border-left: 6px solid black;

  &.link-state-todo {
    border-color: $state-todo-color;
  }
  &.link-state-in_progress {
    border-color: $state-inprogress-color;
  }
  &.link-state-closed {
    border-color: $state-closed-color;
  }
}
</style>